****Make sure to use the correct field for the strata name ****.
****Check the achieved sample and population figures ****.
set width=150.
set length=60.

GET
  FILE='C:\WinDem\SACMEQ2\bot\merg_bot.SAV'.
EXECUTE .

string stratum (a3).
***** Special stratification for Botswana *****.
compute stratum=region.
if (district=" 27") stratum="  7".
***** Special stratification for Botswana *****.

SORT CASES BY
 idschool (A) .

AGGREGATE
  /OUTFILE='C:\WinDem\SACMEQ2\bot\W1.sav'
  /BREAK= idschool stratum
  /numstu=N.

GET
  FILE='C:\WinDem\SACMEQ2\bot\W1.SAV'.
EXECUTE .

AGGREGATE
  /OUTFILE='C:\WinDem\SACMEQ2\Bot\W2.sav'
  /BREAK=stratum
  /sumnum=sum(numstu)
  /schperst=N.

GET
  FILE='C:\WinDem\SACMEQ2\bot\shq_bot.SAV'.
EXECUTE .

*************** SPECIAL CORRECTION FOR BOTSWANA ********************.
compute IDREG=number(region,f3.0).
compute region=string(IDREG,f3.0).
compute IDDIST=number(district,f3.0).
compute district=string(IDDIST,f3.0).
if school=326 spupboy =449.
if school=326 spupgirl=342.
*************** SPECIAL CORRECTION FOR BOTSWANA ********************.

string stratum (a3).
***** Special stratification for Botswana *****.
compute stratum=region.
if (district=" 27") stratum="  7".
***** Special stratification for Botswana *****.

string idschool (a10).
compute idschool=string(school,f10).

compute enr6= spupboy6 +spupgir6.
formats enr6 (f4.0).

sort cases by   idschool (A) .

save outfile='C:\WinDem\SACMEQ2\bot\W3.SAV' /keep stratum idschool enr6.

GET
  FILE='H:\MIOKO\SACMEQ2\Main-sample\Botswana\bot_sel.sav'.
EXECUTE .

string stratum (a3).
***** Special stratification for Botswana *****.
compute stratum=concat("  ",str(idstrata,f1)).
***** Special stratification for Botswana *****.

string idschool (a10).
compute idschool=str(idsch,f10).

sort cases by idschool (a).

MATCH FILES /FILE=*
 /FILE='C:\WinDem\SACMEQ2\bot\W1.sav'
 /FILE='C:\WinDem\SACMEQ2\bot\W3.sav'
 /BY  idschool.
EXECUTE.

sort cases by stratum (a).

MATCH FILES /FILE=*
 /TABLE='C:\WinDem\SACMEQ2\bot\W2.sav'
 /TABLE='H:\MIOKO\SACMEQ2\Main-sample\Botswana\bot_str.sav'
/BY stratum.
EXECUTE.

compute xnumstu=numstu.

compute prob1=schperst*xnumstu/strsize.
compute RF1=1/prob1.
compute pweight1=RF1*3322/39773.

compute prob2=schperst*(mos/strsize)*(xnumstu/enr6).
compute RF2=1/prob2.

compute difenr=abs(mos-enr6).
compute difenr2=mos-enr6.

select if not(missing(numstu)).

sort cases by idschool (A).
Save outfile='C:\WinDem\SACMEQ2\bot\W4.sav' /keep stratum reg_nam dis_nam  idschool mos strsize schperst 
enr6 difenr difenr2 numstu   xnumstu prob1 RF1 pweight1 prob2 RF2 .

GET
  FILE='C:\WinDem\SACMEQ2\bot\W4.SAV'.
EXECUTE .

sort cases by stratum (a) idschool (A).

SUMMARIZE
  /TABLES=stratum reg_nam dis_nam idschool mos strsize schperst enr6 difenr
  difenr2 numstu xnumstu prob1 rf1 pweight1 prob2 rf2
  /FORMAT=VALIDLIST NOCASENUM TOTAL
  /TITLE='Case Summaries'
  /MISSING=VARIABLE
  /CELLS=COUNT .

GET
  FILE='C:\WinDem\SACMEQ2\bot\merg_bot.SAV'.
EXECUTE .

string stratum (a3).
***** Special stratification for Botswana *****.
compute stratum=region.
if (district=" 27") stratum="  7".
***** Special stratification for Botswana *****.

SORT CASES BY
 idschool (A) .

MATCH FILES /FILE=*
 /TABLE='C:\WinDem\SACMEQ2\bot\W4.sav'
 /RENAME (stratum = d0)
 /BY idschool.
EXECUTE.

USE ALL.
COMPUTE filter_$=(stratum ~= d0).
VARIABLE LABEL filter_$ 'stratum ~= d0 (FILTER)'.
VALUE LABELS filter_$  0 'Not Selected' 1 'Selected'.
FORMAT filter_$ (f1.0).
FILTER BY filter_$.
EXECUTE .

SUMMARIZE
  /TABLES=country region district school stratum d0 reg_nam dis_nam
  /FORMAT=VALIDLIST NOCASENUM TOTAL
  /TITLE='Case Summaries'
  /MISSING=VARIABLE
  /CELLS=COUNT .

FILTER OFF.
USE ALL.
EXECUTE .

compute pweight2=RF2*3322/39305.9439895157.
EXECUTE.

weight off.

variable labels
 MOS "WGT:/ Measure of Size during Sampling " 
/ STRSIZE "WGT:/ Strata Size " 
/ SCHPERST "WGT:/ School per stratum " 
/ ENR6 "WGT:/ Total enrolment of Grade 6 during Data collection " 
/ DIFENR "WGT:/ Difference between MOS and ENR6 " 
/ DIFENR2 "WGT:/ Absolute difference between MOS and ENR6 " 
/ NUMSTU "WGT:/ Number of students at each school " 
/ XNUMSTU "WGT:/ Theoritical Number of students at each school " 
/ PROB1 "WGT:/ Probability of a pupil being selected (for pweight1) " 
/ RF1 "WGT:/ Raising Factor (for pweight1) " 
/ PWEIGHT1 "WGT:/ PUPIL WEIGHT (SUMWGT=#PUPIL/COUNTRY during sampling " 
/ PROB2 "WGT:/ Probability of a pupil being selected (for pweight2) " 
/ RF2 "WGT:/ Raising Factor (for pweight2) " 
/ PWEIGHT2 "WGT:/ PUPIL WEIGHT (SUMWGT=#PUPIL/COUNTRY during data collection " 
.

Save outfile='C:\WinDem\SACMEQ2\bot\merg1bot.sav' /drop d0 reg_nam dis_nam filter_$ .

GET
  FILE='C:\WinDem\SACMEQ2\bot\merg1bot.SAV'.
EXECUTE .

title 'Weighted by RF1'.

WEIGHT
  BY RF1 .

FREQUENCIES
  VARIABLES=stratum 
  /ORDER  ANALYSIS .

title 'Weighted by pweight1'.

WEIGHT
  BY pweight1 .

FREQUENCIES
  VARIABLES=stratum
  /ORDER  ANALYSIS .

title 'Weighted by RF2'.

WEIGHT
  BY RF2 .

FREQUENCIES
  VARIABLES=stratum 
  /ORDER  ANALYSIS .
FILTER OFF.

title 'Weighted by pweight2'.

WEIGHT
  BY pweight2 .

FREQUENCIES
  VARIABLES=stratum
  /ORDER  ANALYSIS .

***** Checking PWEIGHT2 *****.

GET
  FILE='C:\WinDem\SACMEQ2\bot\merg1bot.SAV'.
EXECUTE .

compute w2numstu=pweight2*xnumstu.
formats w2numstu (F8.5).

AGGREGATE
  /OUTFILE='C:\WinDem\SACMEQ2\Bot\W5.SAV'
  /BREAK=idschool
  /nwtdscl=first(w2numstu).

GET
  FILE='C:\WinDem\SACMEQ2\bot\merg1bot.SAV'.
EXECUTE .

sort cases by idschool (a).

MATCH FILES /FILE=*
 /TABLE='C:\WinDem\SACMEQ2\Bot\W5.SAV'
 /BY idschool.
EXECUTE.

compute checkwt=schperst*(mos/strsize)*(nwtdscl/enr6).
execute.
formats checkwt (f8.5).

FREQUENCIES
  VARIABLES=checkwt 
  /ORDER  ANALYSIS .
